package interval;

use strict;

#takes: set of windows (list of list, start and end of window)
#returns: fuses windows to a set of non-overlapping windows (list of list)
sub intervaller {
    my $Aregref = shift;
    my @sorted = sort {$a->[0] <=> $b->[0]} @$Aregref;
    my @retur;
    my @buildi = ('0', '0');
    for (my $i=0; $i<scalar(@sorted); $i++) {
	my $union=0;
	if ($buildi[0]==0) {
	    #@buildi = @{$sorted[$i]};
	    @buildi = ($sorted[$i][0], $sorted[$i][1]);
	    if ( $i == scalar(@sorted)-1) {
		push @retur, [@buildi];
		#no need to set buildi at end of @sorted
	    }
	}
	else {
	    #$union = overlap(@buildi, @{$sorted[$i]});
	    $union = overlap(@buildi, $sorted[$i][0], $sorted[$i][1]);
	    if ($union) {
		@buildi=@$union;
		if ( $i == scalar(@sorted)-1) {
		    push @retur, [@buildi];
		    #no need to set buildi at end of @sorted
		}  
	    }
	    else {
		push @retur, [@buildi];
		#@buildi = @{$sorted[$i]};
		@buildi = ($sorted[$i][0], $sorted[$i][1]);
	    }		
	}
    }
    return \@retur;
}

#  takes: four numbers, the first two form window 1, the second two window 2
#returns: the union (ref to two item list, first nr smaller than second nr)
#         or '0' otherwise
sub overlap {
    my ($beg1, $end1, $beg2, $end2) = @_;
    if ($end1 < $beg1) {
	my $tmp = $beg1;
	$beg1=$end1;
	$end1=$beg1;
    }
    if ($end2 < $beg2) {
	my $tmp = $beg2;
	$beg2=$end2;
	$end2=$beg2;
    }
    my $union=0;

    if ($beg1 <= $beg2) {
	if ($end1 < $beg2) {
	    return $union;
	}
	else {
	    if ($end1 <= $end2) {
		$union = [$beg1, $end2];
	    }
	    else {
		$union = [$beg1, $end1];
	    }
	}
    }
    else {
	if ($end2 < $beg1) {
	    return $union;
	}
	else {
	    if ($end2 <= $end1) {
		$union = [$beg2, $end1];
	    }
	    else {
		$union = [$beg2, $end2];
	    }
	}
    }	
    return $union;
}

#  takes: four numbers, the first two form window 1, the second two window 2
#returns: the intersect (ref to two item list, first nr smaller than second nr)
#         or '0' otherwise
sub intersect {
  my ($beg1, $end1, $beg2, $end2) = @_;
  if ($end1 < $beg1) {
    my $tmp = $beg1;
    $beg1=$end1;
    $end1=$beg1;
  }
  if ($end2 < $beg2) {
    my $tmp = $beg2;
    $beg2=$end2;
    $end2=$beg2;
  }
  my $intersect=0;
  
  if ($beg1 <= $beg2) {
    if ($end1 < $beg2) {
      return $intersect;
    }
    else {
      if ($end1 <= $end2) {
	$intersect = [$beg2, $end1];
      }
      else {
	$intersect = [$beg2, $end2];
      }
    }
  }
  else {
    if ($end2 < $beg1) {
      return $intersect;
    }
    else {
      if ($end2 <= $end1) {
	$intersect = [$beg1, $end2];
      }
      else {
	$intersect = [$beg1, $end1];
      }
    }
  }	
  return $intersect;
}

#  takes: four numbers, the first two form window 1, the second two window 2
#returns: ref to two item list:
#         [0] tells you which 'begin' is innermost (1,2 or 0 if equal)
#         [1] tells you which 'end' is innermost (1,2 or 0 if equal)
sub relloc {  #relative location to each other 
    my ($beg1, $end1, $beg2, $end2) = @_;
    if ($end1 < $beg1) {
	my $tmp = $beg1;
	$beg1=$end1;
	$end1=$beg1;
    }
    if ($end2 < $beg2) {
	my $tmp = $beg2;
	$beg2=$end2;
	$end2=$beg2;
    }
    my @relloc;

    if    ($beg1 == $beg2) { $relloc[0]=0 }
    elsif ($beg1  < $beg2) { $relloc[0]=2 }
    else                   { $relloc[0]=1 }
    if    ($end1 == $end2) { $relloc[1]=0 }
    elsif ($end1  < $end2) { $relloc[1]=1 }
    else                   { $relloc[1]=2 }
    return \@relloc;
}


1;
